#ifndef _diffusion_edit_script_h_
#define _diffusion_edit_script_h_ 1

#include "internal/delta_int.h"

typedef enum {
        EDIT_SCRIPT_OP_TYPE_INSERT = 0,
        EDIT_SCRIPT_OP_TYPE_MATCH = 1,
        EDIT_SCRIPT_OP_TYPE_NOOP = 2
} EDIT_SCRIPT_OP_TYPE_T;

typedef struct edit_script_op_s {
        EDIT_SCRIPT_OP_TYPE_T type;
        int start;
        int length;
} EDIT_SCRIPT_OP_T;

typedef struct edit_script_s {
        LIST_T *operations;
} EDIT_SCRIPT_T;

EDIT_SCRIPT_T *edit_script_create();
void edit_script_free(EDIT_SCRIPT_T *script);
DELTA_RESULT_T edit_script_close(EDIT_SCRIPT_T *script);
DELTA_RESULT_T edit_script_match(EDIT_SCRIPT_T *script, int aStart, int length);
DELTA_RESULT_T edit_script_insert(EDIT_SCRIPT_T *script, int bStart, int length);
DELTA_RESULT_T edit_script_delete(EDIT_SCRIPT_T *script, int aStart, int length);
DELTA_RESULT_T edit_script_replacement(EDIT_SCRIPT_T *script, const BUF_T *new_value);
void optimise_edit_script(const EDIT_SCRIPT_T *script);

BUF_T *edit_script_to_cbor(const EDIT_SCRIPT_T *script, const BUF_T *new_value);

#endif
